unit OperatorsTypes;

interface

uses
  SysUtils;

type
  TMioRecord = record
    x: integer;
  end;

  TPointRecord = record
  private
    x, y: Integer;
  public
    procedure SetValue (x1, y1: Integer);
    // class operator Add (a: TPointRecord; b: TMioRecord): TPointRecord;
    // class operator Add (a, b: TMioRecord): TMioRecord;
    class operator Add (a, b: TPointRecord): TPointRecord;
    class operator Explicit (a: TPointRecord) : string;
    class operator Implicit (x1: Integer): TPointRecord;
  end;

 type
  TPointClass = class
  private
    x, y: Integer;
  public
    procedure SetValue (x1, y1: Integer);
    class operator Add (a, b: TPointClass): TPointClass;
    class operator Explicit (a: TPointClass) : string;
  end;

implementation

{ TPointRecord }

class operator TPointRecord.Add(a, b: TPointRecord): TPointRecord;
begin
  Result.x := a.x + b.x;
  Result.y := a.y + b.y;
end;

class operator TPointRecord.Explicit(a: TPointRecord): string;
begin
  Result := Format('(%d:%d)', [a.x, a.y]);
end;

class operator TPointRecord.Implicit(x1: Integer): TPointRecord;
begin
  Result.x := x1;
  Result.y := 0;
end;

procedure TPointRecord.SetValue(x1, y1: Integer);
begin
  x := x1;
  y := y1;
end;

{ TPointClass }

class operator TPointClass.Add(a, b: TPointClass): TPointClass;
begin
  Result := TPointClass.Create;
  Result.x := a.x + b.x;
  Result.y := a.y + b.y;
end;

class operator TPointClass.Explicit(a: TPointClass): string;
begin
  Result := Format('(%d:%d)', [a.x, a.y]);
end;

procedure TPointClass.SetValue(x1, y1: Integer);
begin
  x := x1;
  y := y1;
end;

end.
